import c4d,itertools,random,webbrowser
from c4d import utils as u
from c4d import gui
from c4d.gui import GetInputState
from c4d import Vector
from itertools import tee, islice, chain, izip
from timeit import default_timer as timer

# Cinema 4D Python Script Free Spline Connector 1.0
# Autor: Mike Udin
# http://mikeudin.net


class Dialog(gui.GeDialog):
    cancel = True
    toler = 0.1
    method = True
    
    def CreateLayout(self):
        self.SetTitle("Free Spline Connector 1.0")
        
        self.TabGroupBegin(25, c4d.BFH_CENTER,c4d.TAB_TABS) #tab grup
        
        self.GroupBegin(16, c4d.BFH_CENTER,1, 4,title='Settings') #1 group
        self.GroupBorderSpace(0,5,0,2)
        self.GroupBegin(16, c4d.BFH_CENTER,2, 4,title='mike') # group for text and toler
        
        self.AddStaticText(11, c4d.BFH_RIGHT, 0, 0, "Tolerance: ", 0)
        self.AddEditNumberArrows(55,c4d.BFH_LEFT,70,0)
        self.GroupEnd()
        self.GroupBegin(16, c4d.BFH_CENTER,2, 4,title='')
        self.GroupSpace(20,15)
        self.GroupBorderSpace(10,5,10,5)
        self.AddRadioButton(12, c4d.BFH_CENTER, 80, 0,'Join')
        self.AddRadioButton(13, c4d.BFH_CENTER, 80, 0,'Weld')
        self.GroupEnd()
        self.AddSeparatorH(400,c4d.BFH_CENTER)
        self.GroupBegin(16, c4d.BFH_CENTER,2, 4,title='')
        self.GroupSpace(20,15)
        self.GroupBorderSpace(0,5,0,5)
        self.AddDlgGroup(c4d.DLG_OK|c4d.DLG_CANCEL)
        self.GroupEnd()        
        self.GroupEnd() #1 gr ends
        
        self.GroupBegin(26,c4d.BFV_CENTER,1, 2,title='Info') #2 group
        self.GroupSpace(20,8)
        self.AddStaticText(67, c4d.BFH_LEFT, 423, 1,'',c4d.BORDER_NONE)
        self.AddStaticText(98, c4d.BFH_CENTER, 305, 10,'',c4d.BORDER_NONE)
        self.AddStaticText(99, c4d.BFH_CENTER, 275, 10,'',c4d.BORDER_NONE)
        #self.AddSeparatorH(300,c4d.BFH_FIT)
        self.GroupBegin(26,c4d.BFV_FIT,2, 1,title='About') #2 group
        self.GroupSpace(15,20)
        self.GroupBorderSpace(10,5,10,0)
        #self.AddStaticText(67, c4d.BFH_LEFT, 423, 1,'',c4d.BORDER_NONE)
        self.AddButton(17,c4d.BFH_CENTER,160,20,'Donate $5')
        self.AddButton(77,c4d.BFH_CENTER,160,20,'Donate $10')
        self.GroupEnd()
        self.GroupEnd() #2 group ends
        self.GroupEnd() #tab gr ends
        return True
    
    def InitValues(self) :
        self.SetString(98, "Hi! I'm Mike. Do you like this script?")
        self.SetString(99, "Well, you can thank the author!")
        # self.SetFloat()
        self.SetBool(12,False)
        self.SetBool(13,True)
        self.SetFloat(55,0.1,0,1000)
        
        return True
    
    def Command(self, id, msg):
        if (id == 12):
            self.SetBool(13,False)
        if (id == 13):
            self.SetBool(12,False)
        
        if (id == 1):
            self.cancel = False
            self.toler = self.GetFloat(55)
            self.method = self.GetBool(13)
            self.Close()
        if (id == 2):
            self.Close()
        
        if (id == 17):
            url = "https://www.paypal.me/mikeudinpaypal/5usd"
            webbrowser.open(url, new=2, autoraise=True)     #open in new tab, if possible
        if (id == 77):
            url = "https://www.paypal.me/mikeudinpaypal/10usd"
            webbrowser.open(url, new=2, autoraise=True)     #open in new tab, if possible    
        return True

def previous_and_next(some_iterable):
    prevs, items, nexts = tee(some_iterable, 3)
    prevs = chain([None], prevs)
    nexts = chain(islice(nexts, 1, None), [None])
    return izip(prevs, items, nexts)

def sortListInList(lst,sort_coord): 
    lst.sort(key=lambda x: PositionToDistance(x[1],sort_coord))
    return lst

def mergeSelectedPoints(PointList,PointObj,method=None):
    c4d.CallCommand(13324, 13324) # Deselect All
    op = PointObj
    # print PointList
    select_points=op.GetPointS()
    for i in PointList:
        select_points.Select(i)
    res = True
    # print method
    
    comm = [c4d.MCOMMAND_SPLINE_JOINSEGMENT,c4d.ID_MODELING_WELD_TOOL]
    
    settings = c4d.BaseContainer()
    res = u.SendModelingCommand(command = comm[int(method)],
                                    list = [op],
                                    mode = c4d.MODELINGCOMMANDMODE_POINTSELECTION,
                                    bc = settings,
                                    doc = doc)

    if not res and method:
        print "Something went wrong."


def GetPointIDs(PointObj,num,count,Tolerance,method,counter_p):
    # counter = 0
    # pts = GetEdgeSegmentsPoints(PointObj)
    # print pts
    # return
    nxt = 1
    while True:
        pts = GetEdgeSegmentsPoints(PointObj)
        # print pts
        for previous, item, nxt in previous_and_next(pts):
            if nxt != None:
                if CheckESC(): return [counter_p,True]
                point_dist = PositionToDistance(item[1],nxt[1])
                if item[2] != nxt[2] and point_dist <= Tolerance:
                    # print 'Point: ',item[0],'in segment: ',item[2], ' with point: ',nxt[0],'in segment: ',nxt[2]
                    c4d.StatusSetText("Object " + str(num) + ' of '+ str(count) + ". Processed points: " + str(counter_p))
                    c4d.gui.SetMousePointer(c4d.MOUSE_BUSY)
                    if not method and point_dist == 0: method = True
                    mergeSelectedPoints([item[0],nxt[0]], PointObj,method) 
                    counter_p += 1
                    break
                elif item[2] == nxt[2] and method == True and point_dist <= Tolerance:
                    PointObj.SetPoint(item[0],u.MixVec(nxt[1], item[1], 0.5))
                    PointObj.SetPoint(nxt[0],u.MixVec(nxt[1], item[1], 0.5))
        if nxt == None: break         
    return [counter_p,None] 

# def VectToList(vector): return (round(vector[0],2),round(vector[1],2),round(vector[2],2))

def PositionToDistance(v1,v2): 
    direction = v1 - v2
    return direction.GetLength()

def CheckESC():
    bc = c4d.BaseContainer()
    rs = GetInputState(c4d.BFM_INPUT_KEYBOARD, c4d.KEY_ESC, bc)
    mes = 'Script is stopped.\nContinue the process?'
    if rs and bc[c4d.BFM_INPUT_VALUE]:
        # print "ESC PRESSED --- Exit ----"
        if gui.MessageDialog(mes,4) == 6: return False
        return True

def GetEdgeSegmentsPoints(obj,sort_coord=None):
    listy = []
    segment_count = obj.GetSegmentCount()
    for i in range(segment_count):
        segment = obj.GetSegment(i)
        segment_fp = obj.GetSplinePoint(0,i)
        segment_lp = obj.GetSplinePoint(1,i)
        if i == 0:
            segment_fp_index = 0
            segment_lp_index = segment["cnt"] - 1
        else:
            segment_fp_index = segment_lp_index + 1
            segment_lp_index = (segment_fp_index + segment["cnt"]) - 1
        listy.append([segment_fp_index,segment_fp,i])
        listy.append([segment_lp_index,segment_lp,i])
    if not sort_coord:
        sort_coord = listy[random.randint(0,len(listy)-1)][1]
          # if len(listy) >=300: return sortListInList(listy,sort_coord)
    return sortListInList(listy,sort_coord)


def main():
    
    objs = doc.GetActiveObjects(2)
    if not objs or not any(isinstance(obj, c4d.SplineObject) for obj in objs):
        c4d.gui.MessageDialog("Please select some Splines")
        return

    dial = Dialog()
    dial.Open(c4d.DLG_TYPE_MODAL)
    if dial.cancel: return
    
    
    t = dial.toler
    m = dial.method 
    start = timer()
    counter_o = 0
    spline_res = [0,False]
    counter_p = 0
    # doc.StartUndo()
    for obj in objs:
        if not obj.CheckType(5101): break
        if obj.GetSegmentCount() <= 1: break

        spline_closed = obj.IsClosed()
        if spline_closed: obj[c4d.SPLINEOBJECT_CLOSED] = 0
        # doc.AddUndo(c4d.UNDOTYPE_CHANGE_NOCHILDREN, obj)
        spline_res = GetPointIDs(obj, objs.index(obj)+1, len(objs),t,m,counter_p)
        counter_p = spline_res[0]
        # print 'end spline', counter_p
        counter_o += 1
        obj[c4d.SPLINEOBJECT_CLOSED] = spline_closed
        if spline_res[1]: break
    # doc.EndUndo()
    
    c4d.EventAdd()
    
    end = timer()
    # print(end - start)
    
    if counter_p == 0:
        mes = 'No points for joining.'
    elif counter_o == 0:
        mes = 'Please select some splines.'
    else:
        mes = "Done! Merged " + str(counter_p) + ' points in ' + str(counter_o) + ' objects.' + '\nElapsed time: ' + str(round((end - start),3)) + ' sec.' 
    
    if not spline_res[1]: 
        c4d.StatusSetText(mes)
        if (end - start) > 1.0 or counter_p == 0 or counter_o == 0: gui.MessageDialog(mes)

if __name__=='__main__':
    # c4d.CallCommand(13957, 13957) # Clear Console
    main()    